<template lang="pug">
form.form( @submit.prevent='submit' )
	b-fields
		b-field( :label='$t("default.receive_place")' :on-border='true' expanded )
			b-select( v-if='receiveVariants' v-model='data.receive' :data='receiveVariants' expanded )
		b-field( :label='$t("default.return_place")' :on-border='true' expanded )
			b-select( v-if='returnVariants' v-model='data.return' :data='returnVariants' expanded )
	b-fields
		b-field( :label='$t("default.order_dates")' :on-border='true' )
			b-datepicker( v-model='dates' :disabled='disabledDates' )
		b-field( :label='$t("default.start_time")' :on-border='true' )
			b-input( v-model='timeStart' :max='max' input-type="time" )
		b-field( :label='$t("default.end_time")' :on-border='true' )
			b-input( v-model='timeEnd' :min='min' input-type="time" )
	.tile.is-ancestor
		.tile.is-parent
			car-card.car.tile.is-child( v-if='car && edit' :car='car' )
			.tile.is-child( v-if='!edit' )
				p.heading {{$t("default.car")}}
				car-card( v-if='data.car' :car='data.car' )
				b-button( type="info" @click='carSelector = true' fullwidth ) {{data.car ? $t("default.change_car") : $t("default.select_car")}}
		.tile.is-parent
			b-member.member.tile.is-child( v-if='member && edit' :member='member' )
			.tile.is-child( v-if='!edit' )
				p.heading {{$t("default.member")}}
				b-member.member( v-if='data.client' :member='data.client' )
				b-button( type="info" @click='clientSelector = true' fullwidth ) {{$t("default.select_member")}}
	b-field( v-if='data && [ "createdByAdmin", "created", "payError" ].includes(data.status)' )
		.is-flex.is-align-items-center.is-justify-content-center( v-if='[ "createdByAdmin", "created" ].includes(data.status)' )
			b-button.is-flex-grow-1( node="button" type="primary" :loading='pending' ) {{edit ? $t("buttons.approve") : $t("buttons.create")}}
			b-button.is-flex-grow-1.ml-2( type="danger" light @click='cancel' :loading='pending' ) {{$t("buttons.cancel")}}
		.is-flex.is-align-items-center.is-justify-content-center( v-if='data.status == "payError"' )
			b-button.is-flex-grow-1( node="button" type="success" light :loading='pending' ) {{$t("buttons.retry")}}
			b-button.is-flex-grow-1.ml-2( type="success" @click='resolve' :loading='pending' ) {{$t("buttons.markAsPaid")}}
			b-button.is-flex-grow-1.ml-2( type="danger" light @click='cancel' :loading='pending' ) {{$t("buttons.cancel")}}
	b-field( v-if='!edit' )
		b-button( node="button" type="primary" fullwidth ) {{$t("buttons.save")}}
	car-selector( :active='carSelector' @close='carSelector = false' @select='selectCar' )
	client-selector( :active='clientSelector' @close='clientSelector = false' @select='selectClient' )
</template>

<script setup>
import BField from "@/components/form/Field.vue"
import BFields from "@/components/form/Fields.vue"
import BInput from "@/components/form/Input.vue"
import BSelect from "@/components/form/Select.vue"
import BDatepicker from "@/components/form/Datepicker.vue"
import CarCard from "./CarCard.vue"
import BMember from "./Member.vue"
import CarSelector from "@/components/car/Selector.vue"
import ClientSelector from "@/components/client/Selector.vue"

import dayjs from "@/common/dayjs"
import { getMax, getMin, setFrom, setTo, setTime, toUtc } from "./helpers"
import { ref, watch, computed, onMounted } from "vue"
import { useOrderStore } from "@/stores/order"
import { useSettingsStore } from "@/stores/settings"
import { useI18n } from "vue-i18n"
import { useCarStore } from "@/stores/car"

const props = defineProps({
	defaults: Object,
	edit: Boolean,
	hasRetry: Boolean
})
const emit = defineEmits([ "submit", "cancel" ])

const { locale } = useI18n()
const cs = useCarStore()
const os = useOrderStore()
const ss = useSettingsStore()

const carSelector = ref(false)
const clientSelector = ref(false)

const data = ref(props.defaults || {
	start: dayjs().toDate(),
	end: dayjs().add(1, "day").toDate(),
	receive: "",
	return: "",
	car: "",
	client: ""
})
watch(() => ({ ...props.defaults }), nv => data.value = nv)

const disabledDates = ref([])

// Автомобиль заказа
const car = computed(() => data.value?.Car)
const member = computed(() => data.value?.Member)

// Даты аренды
const dates = computed({
	get: () => ({
		date_from: data.value?.start,
		date_to: data.value?.end
	}),
	set: ({ date_from, date_to }) => {
		if (data.value) {
			data.value.start = setFrom(date_from, date_to)
			data.value.end = setTo(date_from, date_to)
		}
	}
})

// Максимальное значение времени начала аренды
const max = computed(() => getMax(dates.value.date_from, dates.value.date_to))
// Время начала аренды
const timeStart = computed({
	get: () => {
		return dates.value.date_from ? dayjs(dates.value.date_from).format("HH:mm") : null
	},
	set: val => {
		if (val) {
			dates.value = {
				date_to: dates.value.date_to,
				date_from: setTime(dates.value.date_from, val)
			}
		}
	}
})

// Минимальное значение времени окончания аренды
const min = computed(() => getMin(dates.value.date_from, dates.value.date_to))
// Время окончания аренды
const timeEnd = computed({
	get: () => {
		return dates.value.date_to ? dayjs(dates.value.date_to).format("HH:mm") : null
	},
	set: (val, oval) => {
		if (val) {
			dates.value = {
				date_from: dates.value.date_from,
				date_to: setTime(dates.value.date_to, val)
			}
		}
	}
})

const pending = computed(() => os.pending)
const receiveVariants = computed(() => ss.get("rent")?.[locale.value]?.receive)
const returnVariants = computed(() => ss.get("rent")?.[locale.value]?.return)

const selectCar = e => {
	data.value.car = e
	carSelector.value = false
}

const selectClient = e => {
	data.value.client = e
	clientSelector.value = false
}

const submit = () => {
	if (pending.value) return

	let body = JSON.parse(JSON.stringify(data.value))
	
	body.start = body.start ? toUtc(body.start) : ""
	body.end = body.end ? toUtc(body.end) : ""

	emit("submit", body)
}

const cancel = () => {
	if (pending.value) return

	emit("cancel")
}

const resolve = () => {
	if (pending.value) return

	emit("resolve")
}

const fetch = async () => {
	await ss.getSetting("rent")
}

const fetchDates = async () => {
	if (car.value?.id || data.value?.car?.id)
		disabledDates.value = await cs.getDates(car.value?.id || data.value?.car?.id, data.value?.id || "")
}

watch(() => ({ ...data.value }), fetchDates)
watch(() => ({ ...car.value }), fetchDates)
onMounted(async () => {
	await Promise.all([
		fetch(), fetchDates()
	])
})
</script>

<style lang="scss" scoped>

</style>